use super::Ex3Uint;
use crate::impl_from_uint_for;
use candid::Nat;
use num_bigint::BigUint;

impl_from_uint_for!(Ex3Uint, u8, u16, u32, u64, u128, usize);

impl From<BigUint> for Ex3Uint {
    fn from(value: BigUint) -> Self {
        Self(value)
    }
}

impl From<Ex3Uint> for BigUint {
    fn from(value: Ex3Uint) -> Self {
        value.0
    }
}

impl From<Nat> for Ex3Uint {
    fn from(value: Nat) -> Self {
        Self(value.0)
    }
}

impl From<Ex3Uint> for Nat {
    fn from(value: Ex3Uint) -> Self {
        Self(value.0)
    }
}
